<template>
  <div class="ob-dictionary-docs-form">
    <div class="ob-dictionary-docs-form__selects">
      <ob-select
        v-model="localValue.docType"
        label="Тип документа"
        placeholder="Выберите"
        :items="localValue.docTypes"
        :data-qa="dataQa"
        @input="onChange"
      />
      <ob-select
        v-model="localValue.creator"
        label="Кем создаётся"
        placeholder="Выберите"
        :items="localValue.creators"
        :data-qa="dataQa"
        @input="onChange"
      />
    </div>
    <div class="ob-dictionary-docs-form__checkboxes">
      <div class="ob-dictionary-docs-form-caption">
        Используется Для заказов
        <ob-tooltip
          position="top"
          :visible-arrow="false"
        >
          <div slot="content">
            <div
              align="center"
              v-html="'TooltipText'"
            />
          </div>
          <span class="icon question" />
        </ob-tooltip>
      </div>
      <ob-checkbox
        v-model="localValue.usedForCleintExpeditor"
        label="Клиент - Экспедитор"
        :data-qa="dataQa"
        @change="onChange"
      />
      <ob-checkbox
        v-model="localValue.usedForExpeditorContractor"
        label="Экспедитор – Поставщик"
        :data-qa="dataQa"
        @change="onChange"
      />
      <ob-checkbox
        v-model="localValue.usedForCleintContractor"
        label="Клиент - Поставщик"
        :data-qa="dataQa"
        @change="onChange"
      />
    </div>

    <div class="ob-dictionary-docs-form__amounts">
      <div class="ob-dictionary-docs-form-caption">
        Кол-во экземпляров документов (всего {{ total }}) для
      </div>
      <div class="ob-dictionary-docs-form__amounts__list">
        <div class="amount-block client">
          <ob-input
            v-model="localValue.amountForClient"
            label="Клиент"
            placeholder="1"
            :data-qa="dataQa"
            @input="onChange"
          />
        </div><div class="amount-block">
          <ob-input
            v-model="localValue.amountForGp"
            label="ГП"
            placeholder="1"
            :data-qa="dataQa"
            @input="onChange"
          />
        </div><div class="amount-block">
          <ob-input
            v-model="localValue.amountForExpeditor"
            label="Экспедитор"
            placeholder="1"
            :data-qa="dataQa"
            @input="onChange"
          />
        </div><div class="amount-block">
          <ob-input
            v-model="localValue.amountForContractor"
            label="Поставщик"
            placeholder="1"
            :data-qa="dataQa"
            @input="onChange"
          />
        </div><div class="amount-block amount-delete">
          <span
            class="icon close"
            :data-qa="dataQa"
            @click="clear"
          />
        </div>
      </div>
      <div class="ob-dictionary-docs-form-caption amounts-summary">
        Итого в POD клиента: {{ totalPodClient }}
      </div>
      <div class="ob-dictionary-docs-form-caption amounts-summary">
        Итого в POD поставщика: {{ totalPodContractor }}
      </div>
    </div>
  </div>
</template>

<script>
import ObSelect from '../../obComponents/obSelect'
import ObCheckbox from '../../obComponents/obCheckbox'
import ObTooltip from '../obTooltip/index'
import ObInput from '../../obComponents/obInput'

export default {
  components: {
    ObInput,
    ObTooltip,
    ObCheckbox,
    ObSelect
  },
  props: {
    value: {
      type: [Object],
      default: () => {
        return {
          usedForCleintExpeditor: false,
          usedForExpeditorContractor: false,
          usedForCleintContractor: false,

          amountForClient: null,
          amountForGp: null,
          amountForExpeditor: null,
          amountForContractor: null,

          docType: null,
          creator: null,

          docTypes: [],
          creators: []
        }
      }
    },
    dataQa: {
      type: String
    }
  },
  data () {
    return {
      localValue: {
        usedForCleintExpeditor: false,
        usedForExpeditorContractor: false,
        usedForCleintContractor: false,

        amountForClient: null,
        amountForGp: null,
        amountForExpeditor: null,
        amountForContractor: null,

        docType: null,
        creator: null,

        docTypes: [],
        creators: []
      }
    }
  },
  computed: {
    total () {
      return (parseInt(this.localValue.amountForClient) || 0) +
            (parseInt(this.localValue.amountForGp) || 0) +
            (parseInt(this.localValue.amountForExpeditor) || 0) +
            (parseInt(this.localValue.amountForContractor) || 0)
    },
    totalPodClient () {
      return (parseInt(this.localValue.amountForClient) || 0)
    },
    totalPodContractor () {
      return (parseInt(this.localValue.amountForContractor) || 0)
    }
  },
  watch: {
    value (val) {
      this.localValue = val
    }
  },
  mounted () {
    this.localValue = this.value
  },
  methods: {
    clear () {
      this.localValue.amountForClient = null
      this.localValue.amountForGp = null
      this.localValue.amountForExpeditor = null
      this.localValue.amountForContractor = null
      this.onChange()
    },
    onChange () {
      this.$emit('input', this.localValue)
    }
  }
}
</script>

<style lang="scss">
.ob-dictionary-docs-form {
  padding: 20px 0 0 0;
  background: $background-white;
  &:after {
    content: '';
    display: block;
    clear: both;
  }
  .ob-dictionary-docs-form-caption {
    text-transform: uppercase;
    font-variant: small-caps;
    letter-spacing: 0.8px;
    font-size: 9px;
    line-height: 12px;
    color: $color-grey-span;
  }
  &__selects {
    float: left;
    width: 253px;
    margin: 0px 20px 10px 20px;
    > .ob-selector {
      margin-bottom: 10px;
    }
  }
  &__checkboxes {
    float: left;
    width: 227px;
    margin: 0px 10px 20px 10px;
    .question {
      color: $color-blue-navy-blue;
      font-size: 12px;
      font-weight: bold;
      vertical-align: middle;
    }
    > .ob-checkbox-container {
      margin: 10px 0;
      .right-col .label-text {
        letter-spacing: 0.4px;
      }
    }
    > .ob-dictionary-docs-form-caption {
      padding-left: 6px;
    }
  }
  &__amounts {
    float: left;
    width: 440px;
    margin: 0px 20px 20px 20px;
    > .ob-dictionary-docs-form-caption {

    }
    &__list {
      margin-top: 18px;
      margin-bottom: 17px;
      > .amount-block {
        display: inline-block;
        vertical-align: top;
        width: 96px;
        margin-right: 10px;
        &.client {
          width: 83px;
        }
        &.amount-delete {
          padding: 20px 5px;
          cursor: pointer;
          margin-right: 0px;
          width: 24px;
          .close {
            color: $color-grey-border;
          }
        }
      }
    }
    .amounts-summary {
      display: inline-block;
      vertical-align: top;
      min-width: 150px;
      padding-right: 15px;
    }

  }
}
</style>
